package sun.net.www.http;

import java.io.IOException;
import java.io.OutputStream;
import java.io.FilterOutputStream;

public class HttpCaptureOutputStream extends FilterOutputStream
{
    private HttpCapture capture;
    
    public HttpCaptureOutputStream(OutputStream out, HttpCapture capture) {
        super(out);
        this.capture = null;
        this.capture = capture;
    }
    
    @Override
    public void write(int n) throws IOException {
        this.capture.sent(n);
        this.out.write(n);
    }
    
    @Override
    public void write(byte[] b) throws IOException {
        for (int length = b.length, i = 0; i < length; ++i) {
            this.capture.sent((int)b[i]);
        }
        this.out.write(b);
    }
    
    @Override
    public void write(byte[] b, int i, int len) throws IOException {
        for (; i < len; ++i) {
            this.capture.sent((int)b[i]);
        }
        this.out.write(b, i, len);
    }
    
    @Override
    public void flush() throws IOException {
        try {
            this.capture.flush();
        }
        catch (IOException ex) {}
        super.flush();
    }
}
